from dataclasses import dataclass
from pathlib import Path
from rdetoolkit.models.rde2types import RdeInputDirPaths as RdeInputDirPaths, RdeOutputResourcePath as RdeOutputResourcePath

@dataclass
class ProcessingContext:
    index: str
    srcpaths: RdeInputDirPaths
    resource_paths: RdeOutputResourcePath
    datasets_function: _CallbackType | None
    mode_name: str
    excel_file: Path | None = ...
    excel_index: int | None = ...
    smarttable_file: Path | None = ...
    @property
    def basedir(self) -> str: ...
    @property
    def invoice_dst_filepath(self) -> Path: ...
    @property
    def schema_path(self) -> Path: ...
    @property
    def metadata_def_path(self) -> Path: ...
    @property
    def metadata_path(self) -> Path: ...
    @property
    def is_excel_mode(self) -> bool: ...
    @property
    def excel_invoice_file(self) -> Path: ...
    @property
    def is_smarttable_mode(self) -> bool: ...
    @property
    def smarttable_invoice_file(self) -> Path: ...
    def __init__(self, index, srcpaths, resource_paths, datasets_function, mode_name, excel_file=..., excel_index=..., smarttable_file=...) -> None: ...
